﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DatabaseBackup.Library;
using System.IO;
using System.Xml.Linq;
using System.Threading;

namespace DatabaseBackup.Debug
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.Length < 1)
            {
                Console.WriteLine("Please supply an argument. Usage:");
                Console.WriteLine("         /f - A full database backup");
                Console.WriteLine("         /d - A differential backup");
                Console.WriteLine("         /t - A transaction log backup");
                return;
            }

            switch (args[0].ToLower())
            {
                case "/f":
                    FullBackup.PerformFullBackup();
                    break;

                case "/d":
                    DifferentialBackup.PerformDifferentialBackup();
                    break;

                case "/t":
                    TransactionLogBackup.PerformTransactionLogBackup();
                    break;

                default:
                    Console.WriteLine("Invalid argument specified");
                    break;
            }
        }
    }
}
