﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.IO;
using System.Configuration;

namespace DatabaseBackup.Library
{
    public class FullBackup
    {
        public static void PerformFullBackup()
        {
            try
            {
                using (SqlConnection con = new SqlConnection(Helpers.ConnectionString))
                {
                    string[] databases = Helpers.Databases;

                    con.Open();

                    for (int i = 0; i < databases.Count(); i++)
                    {
                        string fileName = string.Format("F-{0}{1:yyyyMMddHHmm}", databases[i], DateTime.UtcNow);

                        StringBuilder query = new StringBuilder();

                        query.Append("BACKUP DATABASE " + databases[i]);
                        query.Append(string.Format(@" TO DISK = '{0}{1}'", Helpers.BackupFolder, fileName + ".bak"));

                        SqlCommand cmd = new SqlCommand(query.ToString(), con);

                        cmd.ExecuteNonQuery();

                        if (Helpers.CompressFiles)
                            fileName = Compression.CompressFile(Helpers.BackupFolder + fileName + ".bak");

                        if (Helpers.FTPEnabled)
                            AmazonS3Handler.TransferFile(fileName);
                    }
                }

                FileHistoryCleanup.CleanOldFiles(FileType.FullBackup);
            }
            catch (Exception ex)
            {
                ErrorHandler.AddToErrorLog(ex, BackupType.Full);
            }
        }
    }
}
